using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Samples.ServiceHosting.StorageClient;
using System.Configuration;

namespace Benday.Azure.Common
{
    public abstract class AzureTableStorageEntity : TableStorageEntity
    {
        internal void InitializeAfterCreate(string partitionKey)
        {
            this.Id = partitionKey;
            RowKey = Guid.Empty.ToString();   
        }

        public AzureTableStorageEntity()
        {
            InitializeAfterCreate(CommonConstants.DEFAULT_PARTITION_KEY);
        }

        public AzureTableStorageEntity(string partitionKey)
        {
            InitializeAfterCreate(partitionKey);
        }

        public virtual string Id { get; set; }

        private string m_partitionKey;
        public override string PartitionKey
        {
            get
            {
                if (m_partitionKey == null)
                {
                    return CommonConstants.DEFAULT_PARTITION_KEY;
                }
                else
                {
                    return m_partitionKey;
                }
            }
            set
            {
                m_partitionKey = value;
            }
        }
        
        public override string RowKey
        {
            get
            {
                return this.Id;
            }
            set
            {
                this.Id = value;
            }
        }
    }
}
