using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Microsoft.Samples.ServiceHosting.StorageClient;
using System.Diagnostics;
using System.Data.Services.Client;
using Microsoft.ServiceHosting.ServiceRuntime;
using System.Globalization;

namespace Benday.Azure.Common
{
    internal static class Log
    {
        internal static void WriteToLog(string logName, string fmt, params object[] args)
        {
            RoleManager.WriteToLog(logName, String.Format(CultureInfo.InvariantCulture, fmt, args));
        }
        internal static void Write(EventKind eventKind, string message, params object[] args)
        {
            if (RoleManager.IsRoleManagerRunning)
            {
                switch (eventKind)
                {
                    case EventKind.Error:
                        WriteToLog("Error", message, args);
                        break;
                    case EventKind.Critical:
                        WriteToLog("Critical", message, args);
                        break;
                    case EventKind.Warning:
                        WriteToLog("Warning", message, args);
                        break;
                    case EventKind.Information:
                        WriteToLog("Information", message, args);
                        break;
                    case EventKind.Verbose:
                        WriteToLog("Verbose", message, args);
                        break;
                }
            }
            else
            {
                switch (eventKind)
                {
                    case EventKind.Error:
                    case EventKind.Critical:
                        Trace.TraceError(message, args);
                        break;
                    case EventKind.Warning:
                        Trace.TraceWarning(message, args);
                        break;
                    case EventKind.Information:
                    case EventKind.Verbose:
                        Trace.TraceInformation(message, args);
                        break;
                }
            }
        }
    }
}
