﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using Microsoft.ServiceHosting.ServiceRuntime;
using HelloWorld.Business;
using Microsoft.Samples.ServiceHosting.StorageClient;

namespace HelloWorld_WebRole
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        protected void m_btnWhatTimeIsIt_Click(object sender, EventArgs e)
        {
            DateTime dateTimeNow = DateTime.Now;
            m_labelCurrentTime.Text = dateTimeNow.ToString();

            RoleManager.WriteToLog("Information", String.Format("Someone asked me what time it was and I told them {0}.", dateTimeNow));            
        }

        protected void m_btnLoadAllPersons_Click(object sender, EventArgs e)
        {
            PersonFacade facade = new PersonFacade();

            m_grid.DataSource = facade.GetAll();
            m_grid.DataBind();
        }

        protected void m_btnSave_Click(object sender, EventArgs e)
        {
            PersonRow person = new PersonRow();

            person.EmailAddress = m_textEmailAddress.Text;
            person.LastName = m_textLastName.Text;
            person.FirstName = m_textFirstName.Text;

            PersonFacade facade = new PersonFacade();

            facade.Save(person);
        }

        protected void m_btnWriteToQueue_Click(object sender, EventArgs e)
        {
            var storage = QueueStorage.Create(StorageAccountInfo.GetDefaultQueueStorageAccountFromConfiguration());

            var queue = storage.GetQueue("helloworldmessages");

            queue.PutMessage(new Message(String.Format("Queued at {0}", DateTime.Now)));
        }

        protected void m_btnCreateQueue_Click(object sender, EventArgs e)
        {
            var storage = QueueStorage.Create(
                StorageAccountInfo.GetDefaultQueueStorageAccountFromConfiguration());

            storage.GetQueue("helloworldmessages").CreateQueue();
        }

        protected void m_btnGetQueueDepth_Click(object sender, EventArgs e)
        {
            var storage = QueueStorage.Create(StorageAccountInfo.GetDefaultQueueStorageAccountFromConfiguration());

            var queue = storage.GetQueue("helloworldmessages");

            var messages = queue.PeekMessages(32);
            
            if (messages == null || messages.Count() == 0)
            {
                m_labelQueueDepth.Text = "Queue depth: 0";
            }
            else
            {
                m_labelQueueDepth.Text = String.Format("Queue depth: {0}", messages.Count());
            }
        }
    }
}
