﻿using System;
using System.Collections.Generic;
using System.Threading;
using System.Linq;
using System.Text;
using Microsoft.ServiceHosting.ServiceRuntime;
using Microsoft.Samples.ServiceHosting.StorageClient;

namespace HelloWorld_WorkerRole
{
    public class WorkerRole : RoleEntryPoint
    {
        public override void Start()
        {
            // This is a sample worker implementation. Replace with your logic.
            RoleManager.WriteToLog("Information", "Worker Process entry point called");

            while (true)
            {
                Thread.Sleep(1000);
                RoleManager.WriteToLog("Information", 
                    "Yup.  Workin' hard.  Makin' moves.  Doin' bizniss.");

                ReadFromQueue();
            }
        }

        private void ReadFromQueue()
        {
            var storage = QueueStorage.Create(StorageAccountInfo.GetDefaultQueueStorageAccountFromConfiguration());

            var queue = storage.GetQueue("helloworldmessages");

            if (queue.DoesQueueExist() == true)
            {
                var message = queue.GetMessage();

                if (message != null)
                {
                    RoleManager.WriteToLog("Information", 
                        String.Format("Queued Message: {0}", message.ContentAsString()));
                }
                else
                {
                    RoleManager.WriteToLog("Information", String.Format("No messages in queue."));
                }
            }            
        }

        public override RoleStatus GetHealthStatus()
        {
            // This is a sample worker implementation. Replace with your logic.
            return RoleStatus.Healthy;
        }
    }
}
